10      CLS
30      PRINT "PC-Medatenerfassung Version 1.2"
40      PRINT "Stand 20.04.1996"
50      PRINT "Uwe Reuter und Conrad Electronic"
55      REM K1 ATemp, K2 VTemp, K3 RTemp, K4 HK-Pumpe, K5 AG-Klappe, ->K6 Boiler
60      PRINT
70      INPUT "Dateiname der Medaten? ", DATEN$
80      DIM WERT(1024, 8)
90      cal$ = "cal.dat"
100     init$ = "init.dat"
110     OPEN init$ FOR INPUT AS #1
120     LINE INPUT #1, text$
130     INPUT #1, ATR
140     CLOSE #1
150     REM DELAY = INT(18550 / ATR)
155     DELAY = 390000
160     j = 0
170     MessStart = TIMER
199     REM
200     K = 1
201     DIN$ = "111101110001": GOTO 260' Kanal 1
202     DIN$ = "111101110011": GOTO 260' Kanal 2
203     DIN$ = "111101111001": GOTO 260' Kanal 3
204     DIN$ = "111101111011": GOTO 260' Kanal 4
205     DIN$ = "111101110101": GOTO 260' Kanal 5
206     DIN$ = "111101110111": GOTO 260' Kanal 6
207     DIN$ = "111101111101": GOTO 260' Kanal 7
208     DIN$ = "111101111111": GOTO 260' Kanal 8
260     B = 512      ' Skalierungsfaktor fuer Dout (Anf.wert)
270     VOUT = 0     ' Vout: dezimale Darstellung von Dout
280     REF = 5      ' Referenzspannung=5,000 V
290     REM
300     FOR i = 1 TO 12   ' Schleife 12 mal durchlaufen (12 Bits)
310             OUT &H3FC, (&HFE AND INP(&H3FC))   ' SClk und CS auf LOW
320             IF MID$(DIN$, 13 - i, 1) = "0" THEN OUT &H3FC, (&HFD AND INP(&H3FC)) ELSE OUT &H3FC, (&H2 OR INP(&H3FC))  ' DIN wird seriell uebertragen
330             OUT &H3FC, (&H1 OR INP(&H3FC))    ' SClk auf HIGH
340             IF (INP(&H3FE) AND 16) = 16 THEN d = 0 ELSE d = 1    ' Datenbit einlesen
350             VOUT = VOUT + (d * B): B = B / 2   ' alle Bits skalieren und summieren
360     NEXT i
400     OUT &H3FC, (&HFD AND INP(&H3FC))    ' DIN und CS auf HIGH
410     OUT &H3FC, (&H2 OR INP(&H3FC))      ' DIN geht auf LOW
450     VIN = (VOUT / 1023) * REF           ' Zahlenwert ausrechnen
460     IF K = 1 THEN 500
470     PRINT "Kanal"; K - 1; "   "; VIN; "Volt"     ' Ergebnis auf Bildschirm ausgeben
480     WERT(j, K - 2) = VIN
490     IF K = 9 THEN GOTO 510              ' Ende eines Messdurchgangs
500     K = K + 1: ON K GOTO 201, 202, 203, 204, 205, 206, 207, 208, 208  ' naechster Kanal
510     j = j + 1
520     FOR i = 1 TO DELAY: NEXT i          ' Warteschleife fuer Betrachtung der Werte
530     PRINT "Ende von Datensatz Nr."; j
540     IF j > 1023 THEN GOTO 800
550     IF INKEY$ = "" THEN GOTO 200        ' bei Tastendruck Programmende
800     MessStop = TIMER
810     MessZeit = MessStop - MessStart
820     DT = MessZeit / j
830     Rate = 1 / DT
1000    REM
1010    REM *************** Kalibrieren *****************************
1100    OPEN cal$ FOR INPUT AS #1
1110    i = 0
1120    LINE INPUT #1, text$
1130    DO WHILE NOT EOF(1)
1140    INPUT #1, knr(i), Gain(i), Offset(i)
1150    i = i + 1
1160    LOOP
1170    CLOSE #1
1200    FOR i = 0 TO j - 1
1210    FOR l = 0 TO 7
1220    WERT(i, l) = Gain(l) * WERT(i, l) + Offset(l)
1230    NEXT l
1240    NEXT i
1800    REM *************** Warmwasserbereitungszeit ****************
1810    FOR i = 0 TO j - 1
1820    IF (WERT(i, 3) < .5 AND WERT(i, 4) > .5) THEN WERT(i, 5) = 1.5
1900    NEXT i
2000    REM
2010    REM *************** Abspeichern *****************************
2020    OPEN DATEN$ FOR OUTPUT AS #1
2030    FOR i = 0 TO j - 1
2035    ZEIT = DT * (i + 1)
2040    PRINT #1, USING "######.####"; ZEIT; WERT(i, 0); WERT(i, 1); WERT(i, 2); WERT(i, 3); WERT(i, 4); WERT(i, 5)
2050    NEXT i
2080    hh = INT(MessZeit / 3600)
2085    mm = INT((MessZeit - 3600! * hh) / 60!)
2090    ss = INT(MessZeit - 60! * mm)
2100    PRINT "Datenstze gespeichert:"; j
2110    PRINT "Gesamte Mezeit:       "; hh; " h "; mm; " min "; ss; " sec"
2120    PRINT "Zykluszeit:            "; DT; " sec"
2130    PRINT "Abtastrate:            "; Rate; " Hz"
2140    PRINT "Warmwasserbereitungszeit berechnet."
2200    CLOSE
9000    END


